# -*- coding: UTF-8 -*-

import logger

uploadFileCode = '/linuxcash/cash/exchangesystems/exchangers/upload.code'
uploadFileDesc = '/linuxcash/cash/exchangesystems/exchangers/upload.text'
unloadFileCode = '/linuxcash/cash/exchangesystems/exchangers/unload.code'
unloadFileDesc = '/linuxcash/cash/exchangesystems/exchangers/unload.text'


class upload():
    PROGRAM_START           = ('0', 'Старт программы.')
    FOUND_FLAG              = ('1', 'Найден флаг.')
    START_CONVERT           = ('2', 'Начало конвертирования.')
    START_REBUILD_CONVERT   = ('3', 'Перезапуск конвертации справочника.')
    TRANSACTION_START       = ('4', 'Начало отправки сообщений в очередь.')
    ADD_PACKAGE             = ('5', 'Идет загрузка справочников.')
    TRANSACTION_END         = ('6', 'Отправка сообщений в очередь прошла успешно.')
    PROGRAM_FINISH          = ('7', 'Программа завершена.')
    
    ERROR_PROGRAM_START     = ('100', 'Ошибка запуска программы.')
    ERROR_TRANSACTION_START = ('101', 'Ошибка при отправлении сообщения: "Начало транзакции".')
    ERROR_TRANSACTION_END   = ('102', 'Ошибка при отправлении сообщения: "Конец транзакции".')
    ERROR_CONVERT           = ('103', 'Ошибка при конвертировании.')
    ERROR_READ_NODES        = ('104', 'Ошибка считывания нод.')
    ERROR_READ_INI          = ('105', 'Конфигурационный файл "exchangers.ini" не найден.')


class unload():
    PROGRAM_START           = ('0', 'Старт программы.')
    GET_DOCUMENTS           = ('1', 'Выборка документов.')
    CONVERT_START           = ('2', 'Начало конвертирования.')
    CONVERT_END             = ('3', 'Конвертирование завершено. Создан(ы) файл(ы) продаж.')
    SET_FLAG_UNLOAD         = ('4', 'Создан файл-флаг выгрузки.')
    SALES_SENT              = ('5', 'Продажи отправлены.')
    UNLOAD_FINISH           = ('6', 'Выгрузка продаж завершена успешно.')
        
    ERROR_ALREADY_RUN       = ('100', 'Невозможно запустить выгрузку товаров. Выгрузка уже запущена.')
    ERROR_UNKNOWN           = ('101', 'Произошла неизвестная ошибка.')
    ERROR_IMPORT_PLUGIN     = ('102', 'Ошибка при импорте плагина.')
    ERROR_CONVERT           = ('103', 'Ошибка при конвертировании в файл(ы) продаж.')
    ERROR_SEND_SALES        = ('104', 'Ошибка при отправке продаж.')
    ERROR_READ_INI          = ('105', 'Конфигурационный файл "exchangers.ini" не найден.')
    ERROR_OPTIONS           = ('106', 'Ошибка в параметрах startReader.')


def setUploadStatus(status):
    if logger.location == 'cash':
        with open(uploadFileCode, 'w') as f:
            f.write(status[0])
        with open(uploadFileDesc, 'w') as f:
            f.write(status[1])


def setUnloadStatus(status):
    if logger.location == 'cash':
        with open(unloadFileCode, 'w') as f:
            f.write(status[0])
        with open(unloadFileDesc, 'w') as f:
            f.write(status[1])
        