# -*- coding: UTF-8 -*-

from unload.converter.atol.atolbasic import AtolBasic


class AtolAstor(AtolBasic):
    """
    @brief Реализация Атол-Астор
    """
    def insertPositionData(self, file, timeTrans, typeTrans, cashCode, docNum, invent, code, quant, pos12, opTypeInKKM, shiftNum, pos15, pos16, pos20, pos26, shopCode, aspectcode):
        self.insertData(file, timeTrans, typeTrans, cashCode, docNum, invent["userCode"], pos16, aspectcode, invent['finalPrice'], quant, pos12, opTypeInKKM, shiftNum, pos15, 
                code, '', '', invent['barCode'], pos20, '', '', '', '', '', pos26, shopCode, '', '', '')

    def insertTaxData(self, file, timeTrans, typeTrans, cashCode, docNum, invent, code, quant, pos12, opTypeInKKM, shiftNum, pos15, pos16, pos20, pos26, shopCode, aspectcode):
        """
        @brief Добавление данных о налоге
        """
        taxgroupcode = invent['vatcode1'] / 100
        vatcode = taxgroupcode if taxgroupcode else invent['vatcode1']
        self.insertData(file, timeTrans, typeTrans, cashCode, docNum, invent["userCode"], pos16, aspectcode, vatcode, vatcode, 
                        invent['vatsum1'], opTypeInKKM, shiftNum, pos15, pos16, '', '', invent['barCode'], pos20, '', '', '', '', '', pos26, shopCode, '', '', '')
        
    def insertDiscountData(self, file, timeTrans, typeTrans, cashCode, docNum, userCode, cardNumber, discType, discRate, discSum, opTypeInKKM, shiftNum, discScheme, discCode, pos26, shopCode, position):
        """
        @brief Добавление данных о скидке
        """
        aspectcode = position['aspectvaluesetcode'] if position['aspectvaluesetcode'] else ''
        self.insertData(file, timeTrans, typeTrans, cashCode, docNum, userCode, cardNumber, aspectcode, discType, discRate, discSum, opTypeInKKM, shiftNum, 
            discScheme, discCode, '', position['inventCode'], '', '', '', '', '', '', '', pos26, shopCode, '', '', '')


atolAstor = AtolAstor()


def parseFlag(flag):
    return atolAstor.parseFlag(flag)


def run(salesFunc, securityLogsFunc, shiftsFunc, cash, node, workDirectory, currentSales):
    atolAstor.run(salesFunc, securityLogsFunc, shiftsFunc, cash, node, workDirectory, currentSales)


def sendSales(cash, node, workDirectory, backupDir):
    return atolAstor.sendSales(cash, node, workDirectory, backupDir)


def sendOnlineSales(cash, node, workDirectory):
    return atolAstor.sendOnlineSales(cash, node, workDirectory)


def getSaleFiles():
    return atolAstor.getSaleFiles()
