# -*- coding: UTF-8 -*-

import types
import pymysql
import pymysql.converters
import pymysql.constants

# pymysql не совсем корректно работает с массивами и кортежами, когда их передаешь, чтобы подставить в запрос " value IN %s "
# значения, которые есть в кортеже оборачиваются дополнитьльно в кавычки, поэтому запрос отрабатывает не так как ожидалось
# Например, ожидали " value IN ('a', 'b', 'c') ", а получаем " value IN ("'a'", "'b'", "'c'") "


def convertDateTime(dateTime):
    if dateTime == u'0000-00-00 00:00:00':
        return None
    return pymysql.converters.convert_datetime(dateTime)


def connect(host='localhost', port=3306, user='netroot', passwd='netroot', db='documentsAll'):
    replaceTupleFunction = lambda s, d: "('%s')" % "','".join(s)

    conversions = pymysql.converters.encoders
    conversions.update(pymysql.converters.decoders)

    conversions[types.TupleType] = replaceTupleFunction
    conversions[types.ListType] = replaceTupleFunction
    conversions[pymysql.FIELD_TYPE.DATETIME] = convertDateTime
    conversions[pymysql.FIELD_TYPE.BIT] = lambda s: ord(s) if s else 0

    return pymysql.connect(host=host, port=port, user=user, password=passwd, db=db, cursorclass=pymysql.cursors.DictCursor, conv=conversions, charset='utf8')