# -*- coding: UTF-8 -*-

from common import logger
from upload.converter.atolPlugins import atolformat

errorObjectsCount = 0

# plugin - плагин, который выполняет загрузку, listObjs - список объектов, которые нужно загрузить,
# size - порог срабатывания загрузки
def loadObjs(inserter, listObjs, size):
    if len(listObjs) >= size:
        inserter.add_package(listObjs)
        listObjs[0:] = []  # объекты загружены - очищаем список

def invalidObjectsCount():
    return errorObjectsCount

def general_method(workDirectory, data, node):
    global errorObjectsCount
    errorList = []
    formatter = atolformat.AtolFormatter()
    formatter.useMultiplicityQuantityForMeasure = node.currentConverter.useMultiplicityQuantityForMeasure
    log = logger.getUploadLogger("Node", node.id)
    plugin = __import__('upload.inserter.%s' % node.inserter.name, fromlist='Inserter')
    cl = getattr(plugin, 'Inserter')
    inserter = cl(node)
    result = inserter.start()
    if result:
        for currentFile in data:
            openFile = open(currentFile, 'rb+')  # 'rb' для корректной работы функции file.tell() в Windows
            line = openFile.readline()
            if not line.strip().startswith('##@@&&'):
                log.error(u'Неверное начало файла %s: %s. Ожидалось: ##@@&&' % (currentFile, line.strip()))
                return False, errorList
            listOfObjs = []
            line = openFile.readline()
            currentCMD = "$$$ADDQUANTITY" # По-умолчанию включен режим добавления товара с добавлением начального остатка
            if line.strip() == '#':
                position = openFile.tell()
                line = openFile.readline()

                while line:  # and line.strip().startswith('$$$'): # команд может быть несколько подряд
                    if line.strip().startswith('$$$'):
                        currentCMD = line.strip()
                        if currentCMD in formatter.emptyCommands.keys():
                            aif_obj = formatter.emptyCommands[currentCMD]
                            listOfObjs.extend(aif_obj if isinstance(aif_obj, list) else [aif_obj])
                            loadObjs(inserter, listOfObjs, node.pack_size)
                            currentCMD = "$$$ADDQUANTITY"
                        elif currentCMD not in formatter.commands.keys():
                            line = openFile.readline()
                            while line and not line.strip().startswith('$$$'):
                                line = openFile.readline()
                            continue
                    elif not line.strip().startswith('//') and line.strip():  # пропускаем коментарии и пустые строки
                        cmd = formatter.commands[currentCMD]
                        aif_obj = None
                        try:
                            aif_obj = cmd(line.decode('cp1251'))
                        except Exception as e:
                            errorStr = u'Ошибка в строке %s. %s' % (line.decode('cp1251'), e) 
                            log.error(errorStr)
                            errorList.append(errorStr)
                        if aif_obj:
                            listOfObjs.extend(aif_obj if isinstance(aif_obj, list) else [aif_obj])
                            loadObjs(inserter, listOfObjs, node.pack_size)
                    line = openFile.readline()
                if not line:
                    tmpPos = openFile.tell()
                    openFile.seek(position - 2)
                    openFile.write('@')
                    openFile.seek(tmpPos)
            else:
                log.error(u'Неверная вторая строка: %s. Ожидалось "#"' % line)
                openFile.close()
                return False, errorList
            loadObjs(inserter, listOfObjs, 1)
            openFile.close()
        result = inserter.stop()
        errorObjectsCount = inserter.invalidObjectsCount()
    return result, errorList
